#include <iostream>
#include <list>
#include <set>
#include <algorithm>
using namespace std;

int main()
{
    list<int> liste;
    set<int> set;

    /* Elemente 1 bis 9 in die Liste einfuegen
     */
    for (int i=1; i<=9; i++) {
        liste.push_back(i);
    }

    /* Elemente 17, 0, 13, 2, 11 in den Set-Container einfuegen
     */
    set.insert(17);
    set.insert(0);
    set.insert(13);
    set.insert(2);
    set.insert(11);

    /* beide Mengen ausgeben
     */
    copy (liste.begin(), liste.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
    copy (set.begin(), set.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* verschmolzene Menge ausgeben
     */
    merge (liste.begin(), liste.end(),
           set.begin(), set.end(),
           ostream_iterator<int>(cout," "));
    cout << endl;
}
