#include <iostream>
#include <deque>
#include <algorithm>
#include <functional>
using namespace std;

int main()
{
    deque<int> menge;

    /* Elemente 9 bis 1 und 1 bis 9 in die Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* das 4. Element einer Sortierung festlegen
     *  - links davon sind alle kleiner-gleich
     *  - rechts davon alle groesser-gleich
     */
    nth_element (menge.begin(), menge.begin()+3, menge.end());

    /* Menge wieder ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* das viertletzte Element einer umgekehrten Sortierung festlegen
     */
    nth_element (menge.begin(), menge.end()-5, menge.end(),
                 greater<int>());

    /* Menge wieder ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
