#include <iostream>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

int main()
{
    list<int> menge;

    /* Elemente 6 bis 1 und 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_front(i);    // vorne absteigend
        menge.push_back(i);     // hinten aufsteigend
    }

    PRINT ("menge: ", menge);

    /* Elemente mit dem Wert 5 entfernen
     */
    list<int>::iterator pos;
    pos = remove (menge.begin(), menge.end(),
                  5);

    PRINT ("ohne 5en (alte Groesse): ", menge);

    /* Groesse entsprechend anpassen
     */
    menge.erase (pos, menge.end());

    PRINT ("ohne 5en (neue Groesse): ", menge);

    /* Elemente mit einem Wert kleiner 3 entfernen
     *  - mit Anpassung der Groesse
     */
    menge.erase (remove_if (menge.begin(), menge.end(),
                            bind2nd(less<int>(),3)),
                 menge.end());

    PRINT ("ohne Elemente <3:        ", menge);
}
