#include <iostream>
#include <list>
#include <algorithm>
using namespace std;

bool check (int elem1, int elem2)
{
    return elem1 + 1 == elem2 || elem1 - 1 == elem2;
}

int main()
{
    // Ausgangsdaten
    int daten [16] = { 1, 4, 4, 6, 1, 2, 2, 3, 6, 6, 6, 5, 7, 5, 4, 4};

    /* Ausgangsdaten in die Menge kopieren
     */
    list<int> menge;
    copy (daten, daten+16, back_inserter(menge));

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge ausgeben und dabei aufeinanderfolgende Duplikate entfernen
     */
    unique_copy (menge.begin(), menge.end(),
                 ostream_iterator<int>(cout," "));
    cout << endl;

    /* Menge ausgeben und dabei jeweils Werte entfernen, die
     * 1 kleiner oder 1 groesser sind
     */
    unique_copy (menge.begin(), menge.end(),
                 ostream_iterator<int>(cout," "), check);
}
