#include <iostream>
#include <locale>
#include <string>
#include <cstdlib>
using namespace std;

int main()
{
    /* Locale-Objekt anhand Environment erzeugen
     */
    locale langLocale("");

    /* und dem Output-Steam zuordnen
     */
    cout.imbue (langLocale);

    /* Name auswerten
     */
    if (langLocale.name() == "de_DE" ||
        langLocale.name() == "de" ||
        langLocale.name() == "german") {
          cout << "Sprachumgebung fuer das Eingabeformat: ";
    }
    else {
          cout << "Locale for input: ";
    }

    /* Sprachumgebung fuer Eingaben einlesen
     */
    string s;
    if (! (cin >> s)) {
        cerr  << "ERROR reading locale" << endl;
        return EXIT_FAILURE;
    }
    locale cinLocale(s);

    /* und dem Input-Steam zuordnen
     */
    cin.imbue (cinLocale);

    double wert;
    while (cin >> wert) {
        cout << wert << endl;
    }
}
