#include <iostream>
#include <valarray>
using namespace std;

/* Valarray zeilenweise ausgeben
 *  - "size" war frueher "length"
 */
template<class T>
void printValarray (const valarray<T>& va, int anz)
{
    for (int i=0; i<va.size()/anz; i++) {
        for (int j=0; j<anz; j++) {
            cout << va[i*anz+j] << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

int main()
{
    /* Valarray fuer 12 Elemente
     */
    valarray<double> va(12);

    for (int i=0; i<12; i++) {
        va[i] = i * 1.1;
    }
    printValarray (va, 4);

    valarray<size_t> idx(5);
    idx[0] = 8;
    idx[1] = 11;
    idx[2] = 3;
    idx[3] = 7;
    printValarray (idx, 5);

    printValarray(static_cast<valarray<double> >(va[idx]), 5);

    va[11] = 11.1;
    va[8] = 88.8;
    printValarray(static_cast<valarray<double> >(va[idx]), 5);

    idx[0] = 1;
    idx[1] = 2;
    idx[2] = 5;
    idx[3] = 0;
    va[idx].fill(99);

    printValarray (va, 4);
}
