#include <functional>

template <class T>         
struct hoch : public binary_function<T, int, T>
{
    T operator() (const T& basis, int exp) const {
        T res = 1;
        while (exp > 0) {
            res = res * basis;
            --exp;
        }
        return res;
    }
}; 
