#include <iostream>
#include <set>
#include <algorithm>
using namespace std;

int main()
{
#ifdef __GNUC__
    set<int,less<int> > menge;
#else
    set<int> menge;
#endif

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.insert(i);
    }

    /* Menge ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* Elemente mit dem Wert 3 entfernen
     *  - FEHLER: Algorithmus remove() funktioniert nicht
     */
    //  list<int>::iterator ende;
    //  ende = remove (menge.begin(), menge.end(), 3);

    /* Elemente mit dem Wert 3 entfernen
     *  - OK: Elementfunktion erase() funktioniert
     */
    int anz;
    anz = menge.erase (3);

    /* Anzahl entfernter Elemente ausgeben
     */
    cout << "Anzahl entfernter Elemente: " << anz << endl;

    /* modifizierte Menge komplett ausgeben
     */
    copy (menge.begin(), menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
