#include <iostream>
#include <string>
#include "Queue.h"      // eigene Queue-Klasse
using namespace std;

int main()
{
   try {    
      Queue<string> q;

      // drei Elemente in die Queue einfuegen
      q.push("Hallo, ");
      q.push("es ");
      q.push("nicht ");

      // zwei Elemente auslesen und ausgeben
      cout << q.pop();
      cout << q.pop();

      // weitere zwei Elemente einfuegen
      q.push("geht ");
      q.push("doch!");

      // ein Element ueberlesen
      q.pop();

      // zwei Elemente auslesen und ausgeben
      cout << q.pop();
      cout << q.pop() << endl;

      // Anzahl der Elemente ausgeben
      cout << "Anzahl der Elemente in der Queue: " << q.size() << endl;

      cout << q.pop() << endl;
   }
   catch (const exception& e) {
      cerr << "EXCEPTION: " << e.what() << endl;
   }
}
