#include <iostream>
#include <vector>
#include <algorithm>
#include "PRINT.h"
using namespace std;

bool beideGerade (int elem1, int elem2)
{
    return elem1 % 2 == 0 && elem2 % 2 == 0;
}

int main()
{
    vector<int> menge;

    /* verschiedene Elemente durcheinander in die Menge einfuegen
     */
    menge.push_back(1);
    menge.push_back(3);
    menge.push_back(2);
    menge.push_back(4);
    menge.push_back(5);
    menge.push_back(5);
    menge.push_back(0);

    PRINT ("menge: ", menge);

    /* erstes Vorkommen von zwei gleichen Werten finden
     * und ab da alle Elemente ausgeben
     */
    vector<int>::iterator p1;
    p1 = adjacent_find (menge.begin(), menge.end());

    copy (p1, menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* erstes Vorkommen von zwei geraden Werten finden
     * und ab da alle Elemente ausgeben
     */
    vector<int>::iterator p2;
    p2 = adjacent_find (menge.begin(), menge.end(), beideGerade);

    copy (p2, menge.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;
}
