#include <iostream>
#include <deque>
#include <list>
#include <algorithm>
#include "PRINT.h"
using namespace std;

int main()
{
    deque<int> menge;
    list<int> teilmenge;

    /* Elemente 1 bis 7 zweimal in die Menge einfuegen
     */
    for (int i=1; i<=7; i++) {
        menge.push_front(8-i);
        menge.push_back(i);
    }

    /* Elemente 4 bis 6 in die Teilmenge einfuegen
     */
    for (int j=4; j<=6; j++) {
        teilmenge.push_back(j);
    }

    PRINT ("Menge:     ", menge);
    PRINT ("Teilmenge: ", teilmenge);

    /* Teilmenge in der ersten suchen
     */
    deque<int>::iterator pos;
    pos = find_end (menge.begin(), menge.end(),
                    teilmenge.begin(), teilmenge.end());
    
    /* gefunden ?
     */
    if (pos != menge.end()) {
        cout << "Teilmenge beginnt beim " << (pos - menge.begin()) + 1
             << ". Element" << endl;
    }
    else {
        cout << "Teilmenge nicht gefunden" << endl;
    }
}
